Project Chrono: chrono::vehicle::ChDistanceIdler Class Reference

Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
chrono::vehicle::ChDistanceIdler Class Referenceabstract
VEHICLE module » Tracked vehicles » Idler subsystem

## Description

Base class for an idler subsystem with a fixed distance tensioner.

An idler consists of the idler wheel and a carrier body. The carrier body is connected to the chassis and the idler wheel to the carrier. A linear actuator connects the carrier body and a link body (the chassis or a supsension arm).

`#include <ChDistanceIdler.h>`

Inheritance diagram for chrono::vehicle::ChDistanceIdler:
[legend]
Collaboration diagram for chrono::vehicle::ChDistanceIdler:
[legend]

## Public Member Functions
| ChDistanceIdler (const std::string &name)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual std::shared_ptr< ChBody > | GetCarrierBody () const override
| Return a handle to the carrier body to which the idler wheel is connected.
std::shared_ptr< ChLinkLockLinActuator > | GetTensioner () const
| Get the tensioner motor element.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, const ChVector3d &location, ChTrackAssembly *track) override
| Initialize this idler subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the idler subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the idler subsystem.
virtual void | LogConstraintViolations () override
| Log current constraint violations.
Public Member Functions inherited from chrono::vehicle::ChIdler
GuidePinType | GetType () const
| Return the type of track shoe consistent with this road wheel.
std::shared_ptr< ChTrackWheel > | GetIdlerWheel () const
| Return the idler wheel subsystem.
std::shared_ptr< ChBody > | GetWheelBody () const
| Return the body of the idler wheel.
double | GetWheelRadius () const
| Get the radius of the idler wheel.
virtual void | SetOutput (bool state) override
| Enable/disable output for this subsystem.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Protected Types
enum | PointId { CARRIER , CARRIER_WHEEL , CARRIER_CHASSIS , MOTOR_CARRIER , MOTOR_ARM , NUM_POINTS }
| Identifiers for the various hardpoints. More...

## Protected Member Functions
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual const ChVector3d | GetLocation (PointId which)=0
| Return the location of the specified hardpoint.
virtual double | GetCarrierMass () const =0
| Return the mass of the carrier body.
virtual const ChVector3d & | GetCarrierInertia ()=0
| Return the moments of inertia of the carrier body.
virtual double | GetCarrierVisRadius () const =0
| Return a visualization radius for the carrier body.
virtual double | GetTensionerExtensionTime () const =0
| Return the time to extend the tensioner to prescribed distance.
virtual double | GetTensionerDistance () const =0
| Return the set distance in the tensioner.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChIdler
| ChIdler (const std::string &name)
| Construct an idler subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
std::shared_ptr< ChBody > | m_carrier
| carrier body
std::shared_ptr< ChLinkLockRevolute > | m_revolute
| carrier-chassis revolute joint
std::shared_ptr< ChLinkLockLinActuator > | m_tensioner
| linear motor tensioner element
Protected Attributes inherited from chrono::vehicle::ChIdler
GuidePinType | m_type
| type of the track shoe matching this road wheel
ChVector3d | m_rel_loc
| idler subsystem location relative to chassis
std::shared_ptr< ChTrackWheel > | m_idler_wheel
| idler-wheel subsystem
ChTrackAssembly * | m_track
| containing track assembly
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Enumeration Documentation

## ◆ PointId

enum chrono::vehicle::ChDistanceIdler::PointId
| protected

Identifiers for the various hardpoints.

Enumerator
CARRIER | carrier location
CARRIER_WHEEL | carrier, connection to idler wheel
CARRIER_CHASSIS | carrier, connection to chassis (revolute)
MOTOR_CARRIER | motor connection to carrier
MOTOR_ARM | motor connection to suspension arm

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChDistanceIdler::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| overridevirtual

Add visualization assets for the idler subsystem.

This default implementation adds assets to the carrier body.

Reimplemented from chrono::vehicle::ChPart.

## ◆ ExportComponentList()

void chrono::vehicle::ChDistanceIdler::ExportComponentList | ( | rapidjson::Document & | jsonDocument | ) | const
| overrideprotectedvirtual

Export this subsystem's component list to the specified JSON object.

Derived classes should override this function and first invoke the base class implementation, followed by calls to the various static Export***List functions, as appropriate.

Reimplemented from chrono::vehicle::ChIdler.

## ◆ GetCarrierBody()

virtual std::shared_ptr< ChBody > chrono::vehicle::ChDistanceIdler::GetCarrierBody | ( |  | ) | const
| inlineoverridevirtual

Return a handle to the carrier body to which the idler wheel is connected.

Implements chrono::vehicle::ChIdler.

## ◆ GetCarrierInertia()

virtual const ChVector3d & chrono::vehicle::ChDistanceIdler::GetCarrierInertia | ( |  | ) |
| protectedpure virtual

Return the moments of inertia of the carrier body.

Implemented in chrono::vehicle::DistanceIdler.

## ◆ GetCarrierMass()

virtual double chrono::vehicle::ChDistanceIdler::GetCarrierMass | ( |  | ) | const
| protectedpure virtual

Return the mass of the carrier body.

Implemented in chrono::vehicle::DistanceIdler.

## ◆ GetCarrierVisRadius()

virtual double chrono::vehicle::ChDistanceIdler::GetCarrierVisRadius | ( |  | ) | const
| protectedpure virtual

Return a visualization radius for the carrier body.

Implemented in chrono::vehicle::DistanceIdler.

## ◆ GetLocation()

virtual const ChVector3d chrono::vehicle::ChDistanceIdler::GetLocation | ( | PointId | which | ) |
| protectedpure virtual

Return the location of the specified hardpoint.

The returned location must be expressed in the idler subsystem reference frame.

## ◆ GetTemplateName()

virtual std::string chrono::vehicle::ChDistanceIdler::GetTemplateName | ( |  | ) | const
| inlineoverridevirtual

Get the name of the vehicle subsystem template.

Implements chrono::vehicle::ChPart.

## ◆ GetTensionerDistance()

virtual double chrono::vehicle::ChDistanceIdler::GetTensionerDistance | ( |  | ) | const
| protectedpure virtual

Return the set distance in the tensioner.

Implemented in chrono::vehicle::DistanceIdler.

## ◆ GetTensionerExtensionTime()

virtual double chrono::vehicle::ChDistanceIdler::GetTensionerExtensionTime | ( |  | ) | const
| protectedpure virtual

Return the time to extend the tensioner to prescribed distance.

Implemented in chrono::vehicle::DistanceIdler.

## ◆ Initialize()

void chrono::vehicle::ChDistanceIdler::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | const ChVector3d & | location,
|  | ChTrackAssembly * | track )
| overridevirtual

Initialize this idler subsystem.

The idler subsystem is initialized by attaching it to the specified chassis at the specified location (with respect to and expressed in the reference frame of the chassis). It is assumed that the idler subsystem reference frame is always aligned with the chassis reference frame. A derived idler subsystem template class must extend this default implementation and specify contact geometry for the idler wheel.

Parameters

  [in] | chassis | associated chassis
  [in] | location | location relative to the chassis frame
  [in] | track | containing track assembly

Reimplemented from chrono::vehicle::ChIdler.

## ◆ InitializeInertiaProperties()

void chrono::vehicle::ChDistanceIdler::InitializeInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Initialize subsystem inertia properties.

Derived classes must override this function and set the subsystem mass (m_mass) and, if constant, the subsystem COM frame and its inertia tensor. This function is called during initialization of the vehicle system.

Implements chrono::vehicle::ChPart.

## ◆ LogConstraintViolations()

void chrono::vehicle::ChDistanceIdler::LogConstraintViolations | ( |  | ) |
| overridevirtual

Log current constraint violations.

Implements chrono::vehicle::ChIdler.

## ◆ Output()

void chrono::vehicle::ChDistanceIdler::Output | ( | ChVehicleOutput & | database | ) | const
| overrideprotectedvirtual

Output data for this subsystem's component list to the specified database.

Reimplemented from chrono::vehicle::ChPart.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChDistanceIdler::RemoveVisualizationAssets | ( |  | ) |
| overridevirtual

Remove visualization assets for the idler subsystem.

This default implementation removes the assets from the carrier body.

Reimplemented from chrono::vehicle::ChPart.

## ◆ UpdateInertiaProperties()

void chrono::vehicle::ChDistanceIdler::UpdateInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Update subsystem inertia properties.

Derived classes must override this function and set the global subsystem transform (m_xform) and, unless constant, the subsystem COM frame (m_com) and its inertia tensor (m_inertia). Calculate the current inertia properties and global frame of this subsystem. This function is called every time the state of the vehicle system is advanced in time.

Implements chrono::vehicle::ChPart.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/idler/ChDistanceIdler.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/idler/ChDistanceIdler.cpp